{
Copyright (C) 2002-2008  Massimo Melina (www.rejetto.com)

This file is part of HFS ~ HTTP File Server.

    HFS is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    HFS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with HFS; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit optionsDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Grids, ComCtrls, ValEdit, main;

type
  ToptionsFrm = class(TForm)
    pageCtrl: TPageControl;
    bansPage: TTabSheet;
    accountsPage: TTabSheet;
    accountpropGrp: TGroupBox;
    accountenabledChk: TCheckBox;
    pwdBox: TLabeledEdit;
    accountsBox: TListView;
    Label1: TLabel;
    addaccountBtn: TButton;
    deleteaccountBtn: TButton;
    renaccountBtn: TButton;
    mimePage: TTabSheet;
    mimeBox: TValueListEditor;
    trayPage: TTabSheet;
    Label2: TLabel;
    traymsgBox: TMemo;
    Panel1: TPanel;
    Label3: TLabel;
    accountaccessBox: TTreeView;
    Panel2: TPanel;
    okBtn: TButton;
    applyBtn: TButton;
    cancelBtn: TButton;
    bansBox: TValueListEditor;
    addBtn: TButton;
    deleteBtn: TButton;
    Panel3: TPanel;
    noreplybanChk: TCheckBox;
    Button1: TButton;
    a2nPage: TTabSheet;
    Panel4: TPanel;
    Label4: TLabel;
    a2nBox: TValueListEditor;
    ignoreLimitsChk: TCheckBox;
    Panel5: TPanel;
    addMimeBtn: TButton;
    deleteMimeBtn: TButton;
    deleteA2Nbtn: TButton;
    addA2Nbtn: TButton;
    iconsPage: TTabSheet;
    iconMasksBox: TMemo;
    iconsBox: TComboBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure accountsBoxSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure addaccountBtnClick(Sender: TObject);
    procedure deleteaccountBtnClick(Sender: TObject);
    procedure accountsBoxEdited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure renaccountBtnClick(Sender: TObject);
    procedure accountenabledChkClick(Sender: TObject);
    procedure accountsBoxKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure accountaccessBoxDblClick(Sender: TObject);
    procedure accountaccessBoxContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure cancelBtnClick(Sender: TObject);
    procedure okBtnClick(Sender: TObject);
    procedure applyBtnClick(Sender: TObject);
    procedure addBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure deleteBtnClick(Sender: TObject);
    procedure pwdBoxEnter(Sender: TObject);
    procedure pwdBoxExit(Sender: TObject);
    procedure addMimeBtnClick(Sender: TObject);
    procedure deleteMimeBtnClick(Sender: TObject);
    procedure addA2NbtnClick(Sender: TObject);
    procedure deleteA2NbtnClick(Sender: TObject);
    procedure iconsBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure iconsBoxDropDown(Sender: TObject);
    procedure iconsBoxChange(Sender: TObject);
    procedure iconMasksBoxChange(Sender: TObject);
  public
		procedure loadAccountProperties();
		procedure saveAccountProperties();
    procedure addAccountInList(a:Taccount);
		procedure deleteAccount(i:integer=-1);
    procedure loadValues();
    function  saveValues():boolean; // it may fail on incorrect input
    function  checkValues():string; // returns an error message
    procedure updateIconMap();
    procedure updateIconsBox();
  end;

var
  optionsFrm: ToptionsFrm;

implementation

{$R *.dfm}

uses
  utilLib, HSlib, strUtils, classesLib;

var
  lastAccountSelected: integer = -1; // stores the previous selection index
  tempAccounts: Taccounts; // the GUI part can't store the temp data
  tempIcons: array of integer;

procedure ToptionsFrm.loadValues();
var
  i:integer;
begin
// bans
noreplybanChk.checked:=noReplyBan;
bansBox.Strings.Clear();
for i:=0 to length(banList)-1 do
	bansBox.strings.Add(banList[i].ip+'='+banlist[i].comment);
// mime types
mimeBox.Strings.Clear();
for i:=0 to length(MIMEtypes) div 2-1 do
	mimeBox.strings.Add(MIMEtypes[i*2]+'='+MIMEtypes[i*2+1]);
// address2name
a2nBox.Strings.clear();
for i:=0 to length(address2name) div 2-1 do
	a2nBox.strings.Add(address2name[i*2]+'='+address2name[i*2+1]);
// tray message
traymsgBox.Text:=x_template(trayMsg,[#13,CRLF]);
// accounts
accountsBox.Clear();
for i:=0 to length(accounts)-1 do addAccountInList(accounts[i]);
tempAccounts:=accounts;
lastAccountSelected:=-1;
loadAccountProperties();
// icons
updateIconsBox();
i:=length(iconMasks);
setLength(tempIcons, i+1);
iconMasksBox.Text:='';
for i:=0 to i-1 do
  begin
  iconMasksBox.lines.Add(iconMasks[i].str);
  tempIcons[i]:=iconMasks[i].int;
  end;
iconMasksBox.SelStart:=0;
end; // loadValues

function ToptionsFrm.checkValues():string;
var
  i: integer;
  s: string;
begin
for i:=bansBox.Strings.count downto 1 do
  begin
  bansbox.cells[0,i]:=trim(bansbox.cells[0,i]);
  s:=bansbox.cells[0,i];
  if s = '' then continue;
  if bansBox.strings.indexOfName(s)+1 < i then
    begin
    result:=format('Bans: "%s" is duplicated', [s]);
    exit;
    end;
  if not checkAddressSyntax(s) then
    begin
    result:=format('Bans: syntax error for "%s"', [s]);
    exit;
    end;
  end;
for i:=a2nBox.Strings.count downto 1 do
  begin
  s:=trim(a2nBox.cells[1,i]);
  if trim(s+a2nBox.cells[0,i]) = '' then
    a2nBox.DeleteRow(i)
  else
    if (s>'') and not checkAddressSyntax(s) then
      begin
      result:=format('Address2name: syntax error for "%s"', [s]);
      exit;
      end;
  end;
result:='';
end; // checkValues

function ToptionsFrm.saveValues():boolean;
var
  i, n: integer;
  s: string;
begin
result:=FALSE;
s:=checkValues();
if s > '' then
  begin
  msgDlg(s, MB_ICONERROR);
  exit;
  end;
// bans
noReplyBan:=noreplybanChk.checked;
i:=bansbox.Strings.Count;
if bansbox.Cells[0,i] = '' then dec(i);
setlength(banlist, i);
n:=0;
for i:=0 to length(banlist)-1 do
  begin
  banlist[i].ip:=trim(bansBox.Cells[0,i+1]);
  if banlist[i].ip = '' then continue
  else inc(n);
  banlist[i].comment:=bansBox.Cells[1,i+1];
  end;
setlength(banlist, n);
kickBannedOnes();
// mime types
MIMEtypes:=NIL;
for i:=1 to mimebox.RowCount-1 do
  addArray(MIMEtypes, [mimeBox.Cells[0,i], mimeBox.Cells[1,i]]);
// address2name
address2name:=NIL;
for i:=1 to a2nBox.RowCount-1 do
  begin
  s:=trim(a2nBox.Cells[1,i]);
  if s > '' then addArray(address2name, [a2nBox.Cells[0,i], s]);
  end;
// tray message
trayMsg:=x_template(traymsgBox.Text, [#10,'']);
// accounts
saveAccountProperties();
accounts:=tempAccounts;
purgeVFSaccounts();
mainfrm.filesBox.repaint();
// icons
n:=0;
for i:=0 to iconMasksBox.Lines.Count-1 do
  begin
  s:=iconMasksBox.Lines[i];
  if trim(s) = '' then continue;
  inc(n);
  setlength(iconMasks, n);
  iconMasks[n-1].str:=s;
  iconMasks[n-1].int:=tempIcons[i];
  end;
result:=TRUE;
end; // saveValues

procedure ToptionsFrm.FormShow(Sender: TObject);
var
  i: integer;
  s: string;
begin
setwindowlong(handle, GWL_HWNDPARENT, 0);
loadValues();
if pageCtrl.activePage <> a2nPage then exit;
s:=mainfrm.ipPointedInLog();
if s = '' then exit;
// select row or insert new one
i:=length(address2name)-1;
while (i > 0) and not addressmatch(address2name[i], s) do
  dec(i, 2);
if i > 0 then a2nBox.Row:=i
else a2nBox.row:=a2nBox.InsertRow('',s,TRUE);

a2nBox.SetFocus();
a2nBox.EditorMode:=TRUE;
end;

procedure ToptionsFrm.FormResize(Sender: TObject);
begin bansBox.ColWidths[1]:=bansBox.ClientWidth-bansBox.colWidths[0]-2 end;

procedure setEnabledRecur(c:Twincontrol; v:boolean);
var
  i: integer;
begin
c.Enabled:=v;
for i:=0 to c.ControlCount-1 do
	begin
  c.controls[i].Enabled:=FALSE;
  if c.controls[i] is Twincontrol then
  	setEnabledRecur(c.controls[i] as Twincontrol, v);
  end;
end; // setEnabledRecur

procedure ToptionsFrm.loadAccountProperties();
var
  a: Taccount;
  b: boolean;
  n: Ttreenode;
  f: Tfile;
begin
saveAccountProperties();
lastAccountSelected:=accountsBox.ItemIndex;
b:=lastAccountSelected >= 0;
setEnabledRecur(accountpropGrp, b);
renAccountBtn.enabled:=b;
deleteAccountBtn.enabled:=b;
label3.enabled:=b;
accountAccessBox.Enabled:=b;
if not accountpropGrp.Enabled then exit;
a:=tempAccounts[lastAccountSelected];
accountEnabledChk.checked:=a.enabled;
pwdBox.Text:=a.pwd;
ignoreLimitsChk.Checked:=a.noLimits;

accountAccessBox.items.Clear();
n:=rootNode;
while n <> NIL do
  begin
  f:=Tfile(n.data);
  if assigned(f) and stringExists(a.user, f.accounts) then
    with accountAccessBox.Items.AddObject(NIL, f.name, f.node) do
      begin
      ImageIndex:=f.node.ImageIndex;
      SelectedIndex:=ImageIndex;
      end;
  n:=n.GetNext();
  end;
end; // loadAccountProperties

procedure ToptionsFrm.saveAccountProperties();
const
  MSG = 'Invalid password.'
  	+#13'The characters below are not allowed'
    +#13'/\:?*"<>|;&&@';
var
  a:^Taccount;
begin
if lastAccountSelected < 0 then exit;
if (pwdBox.text > '') and not validUsername(pwdbox.Text) then
  begin
	msgDlg(MSG, MB_ICONERROR);
  exit;
  end;
a:=@tempAccounts[lastAccountSelected];
a.enabled:=accountEnabledChk.checked;
a.pwd:=pwdBox.Text;
a.noLimits:=ignoreLimitsChk.checked;
end; // saveAccountProperties

procedure ToptionsFrm.accountsBoxSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
loadAccountProperties();
end;

procedure ToptionsFrm.addAccountInList(a:Taccount);
var
  it: TlistItem;
begin
it:=Tlistitem.Create(accountsBox.items);
it.ImageIndex:=ifThen(a.enabled, 27, 28);
accountsBox.Items.AddItem(it);
it.Caption:=a.user;
end;

function userExists(s:string):boolean;
var
  i: integer;
begin
result:=TRUE;
for i:=0 to length(tempAccounts)-1 do
  if compareText(s, tempAccounts[i].user) = 0 then
    exit;
result:=FALSE;
end; // userExists

function getUniqueUser():string;
var
  i: integer;
begin
result:='New user';
if not userExists(result) then exit;
i:=2;
  repeat
  result:=format('New user %d', [i]);
  inc(i);
  until not userExists(result);
end; // getUniqueUser

procedure ToptionsFrm.addaccountBtnClick(Sender: TObject);
var
  i: integer;
  a: Taccount;
begin
a.user:=getUniqueUser();
a.pwd:='';
a.enabled:=TRUE;
a.noLimits:=FALSE;

i:=length(tempAccounts);
setLength(tempAccounts, i+1);
tempAccounts[i]:=a;
addAccountInList(a);

accountsBox.ItemIndex:=i;
renaccountBtnClick(sender);
end;

procedure ToptionsFrm.deleteAccount(i:integer=-1);
begin
if i < 0 then
	begin
  i:=accountsBox.ItemIndex;
  if i < 0 then exit;
 	if msgDlg('Delete?', MB_ICONQUESTION+MB_YESNO) = IDNO then
  	exit;
  end;
accountsBox.selected.Delete();
// shift
for i:=i+1 to length(tempAccounts)-1 do
  tempAccounts[i-1]:=tempAccounts[i];
// shorten
setlength(tempAccounts, length(tempAccounts)-1);
end; // deleteAccount

procedure ToptionsFrm.deleteaccountBtnClick(Sender: TObject);
begin deleteAccount() end;

procedure ToptionsFrm.accountsBoxEdited(Sender: TObject; Item: TListItem; var S: String);
begin
if not validUsername(s) or userExists(s) then
  begin
  msgDlg('Invalid username', MB_ICONERROR);
  s:=tempAccounts[item.index].user;
  exit;
  end;
tempAccounts[item.Index].user:=s;
end;

procedure ToptionsFrm.renaccountBtnClick(Sender: TObject);
begin accountsBox.selected.EditCaption() end;

procedure ToptionsFrm.accountenabledChkClick(Sender: TObject);
begin accountsBox.selected.ImageIndex:=ifThen(accountEnabledChk.checked, 27, 28) end;

procedure ToptionsFrm.accountsBoxKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if accountsBox.IsEditing then exit;
if shift = [] then
	case key of
  	VK_F2: accountsBox.selected.EditCaption();
    VK_DELETE: deleteAccount();
    end;
end;

procedure ToptionsFrm.accountaccessBoxDblClick(Sender: TObject);
begin
if accountAccessBox.Selected = NIL then exit;
mainfrm.filesBox.selected:=accountAccessBox.Selected.Data;
mainfrm.SetFocus();
end;

procedure ToptionsFrm.accountaccessBoxContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
if accountAccessBox.Selected = NIL then handled:=TRUE
else mainfrm.filesBox.selected:=accountAccessBox.Selected.Data;
end;

procedure ToptionsFrm.cancelBtnClick(Sender: TObject);
begin close() end;

procedure ToptionsFrm.applyBtnClick(Sender: TObject);
begin saveValues() end;

procedure ToptionsFrm.okBtnClick(Sender: TObject);
begin if saveValues() then close() end;

procedure ToptionsFrm.Button1Click(Sender: TObject);
begin msgDlg(getRes('invertBan')) end;

procedure ToptionsFrm.pwdBoxEnter(Sender: TObject);
begin if pwdBox.Text > '' then pwdBox.passwordChar:=#0 end;

procedure ToptionsFrm.pwdBoxExit(Sender: TObject);
begin pwdBox.passwordChar:='*' end;

procedure ToptionsFrm.addBtnClick(Sender: TObject);
begin bansBox.InsertRow('','',TRUE) end;

procedure ToptionsFrm.deleteBtnClick(Sender: TObject);
begin
if bansbox.strings.count > 0 then
  bansBox.Strings.Delete(bansBox.Row-1)
end;

procedure ToptionsFrm.addMimeBtnClick(Sender: TObject);
begin mimeBox.InsertRow('','',TRUE) end;

procedure ToptionsFrm.deleteMimeBtnClick(Sender: TObject);
begin
if mimeBox.strings.count > 0 then
  mimeBox.Strings.Delete(mimeBox.Row-1)
end;

procedure ToptionsFrm.addA2NbtnClick(Sender: TObject);
begin a2nBox.InsertRow('','',TRUE) end;

procedure ToptionsFrm.deleteA2NbtnClick(Sender: TObject);
begin
if a2nBox.strings.count > 0 then
  a2nBox.Strings.Delete(a2nBox.Row-1)
end;

procedure ToptionsFrm.iconsBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  cnv: TCanvas;
  bmp: Tbitmap;
begin
cnv:=iconsBox.Canvas;
bmp:=Tbitmap.create;
mainfrm.images.GetBitmap(index, bmp);
cnv.FillRect(rect);
cnv.Draw(rect.Left, rect.Top, bmp);
cnv.TextOut(rect.Left+mainfrm.images.Width+2, rect.Top, IntToStr(index));
bmp.free;
end;

procedure ToptionsFrm.updateIconsBox();
begin iconsBox.Items.Text:=dupeString(CRLF, mainfrm.images.count) end;

procedure ToptionsFrm.iconsBoxDropDown(Sender: TObject);
begin updateIconsBox() end;

procedure ToptionsFrm.updateIconMap();
begin
if not iconsBox.DroppedDown then
  iconsBox.ItemIndex:=tempIcons[iconMasksBox.CaretPos.Y];
end;

procedure ToptionsFrm.iconsBoxChange(Sender: TObject);
begin tempIcons[iconMasksBox.CaretPos.Y]:=iconsBox.ItemIndex end;

procedure ToptionsFrm.iconMasksBoxChange(Sender: TObject);
begin setLength(tempIcons, iconMasksBox.Lines.count+1) end;

end.
