{
Copyright (C) 2002-2008  Massimo Melina (www.rejetto.com)

This file is part of HFS ~ HTTP File Server.

    HFS is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    HFS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with HFS; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
{$INCLUDE defs.inc }

unit utilLib;

interface

uses
	main, types, hslib, windows, graphics, dialogs, registry, classes, dateUtils,
  shlobj, shellapi, activex, comobj, strutils, forms, stdctrls, controls, psAPI,
  longinputDlg, wsocket, httpProt, comCtrls, iniFiles, richedit, sysutils;

const
  ILLEGAL_FILE_CHARS = [#0..#31,'/','\',':','?','*','"','<','>','|'];
var
  GMToffset: integer; // in minutes
  inputQueryLongdlg: TlonginputFrm;
  winVersion: (WV_LOWER, WV_2000, WV_VISTA, WV_HIGHER);
type
  TcharSet = set of char;
  PstringDynArray = ^TstringDynArray;

function pid2file(pid:integer):string;
function port2pid(port:integer):integer;
function holdingKey(key:integer):boolean;
function blend(from,to_:Tcolor; perc:real):Tcolor;
function isNT():boolean;
function pred(p:pchar):pchar; overload;
function gap512(i:integer):integer;
function setClip(s:string):boolean;
function eos(s:Tstream):boolean;
function safeDiv(a,b:real):real; overload;
function safeDiv(a,b:int64; default:int64=0):int64; overload;
function copyRTFtoRichEdit(rtf:string; richedit:Trichedit):boolean;
function smartsize(size:int64):string;
function httpGet(url:string):string;
function httpGetFile(url, filename:string; notify:TdocDataEvent=NIL):boolean;
function httpFileSize(url:string):integer;
function getIPs():string;
function getPossibleAddresses():TstringDynArray;
function whatStatusPanel(statusbar:Tstatusbar; x:integer):integer;
function getExternalAddress(var res:string):boolean;
function checkAddressSyntax(address:string; wildcards:boolean=TRUE):boolean;
function max(a,b:integer):integer; overload;
function inputQueryLong(const caption, msg:string; var value:string; ofs:integer=0):boolean;
procedure purgeVFSaccounts();
function min(a,b:integer):integer;
procedure exec(cmd:string; pars:string='');
function execNew(cmd:string):boolean;
function getRes(name:pchar; typ:string='TEXT'):string;
function bmpToHico(bitmap:Tbitmap):hicon;
function compare_(i1,i2:double):integer; overload;
function compare_(i1,i2:int64):integer; overload;
function compare_(i1,i2:integer):integer; overload;
function msgDlg(msg:string; code:integer=0; title:string=''):integer;
function ifThen(v:boolean; v1,v2:int64):int64; overload;
function ifThen(v:boolean; v1:integer; v2:integer=0):integer; overload;
function ifThen(v:boolean; v1:Tobject; v2:Tobject=NIL):Tobject; overload;
// file
function getTempDir():string;
function createShellLink(linkFN:WideString; destFN:string):boolean;
function getShellFolder(id:string):string;
function getTempFilename():string;
function saveTempFile(data:string):string;
function fileOrDirExists(fn:string):boolean;
function sizeOfFile(fn:string):int64; overload;
function sizeOfFile(fh:Thandle):int64; overload;
function loadFile(fn:string):string;
function saveFile(fn:string; data:string; append:boolean=FALSE):boolean; overload;
function saveFile(var f:file; data:string):boolean; overload;
function resolveLnk(fn:string):string;
function validFilepath(fn:string):boolean;
function validFilename(s:string):boolean;
function filematch(mask, fn:string):boolean;
function appendFile(fn:string; data:string):boolean;
function getFilename(var f:file):string;
function filenameToDriveByte(fn:string):byte;
function selectFiles(caption:string; var files:TStringDynArray):boolean;
function selectFolder(caption:string; var folder:string):boolean;
function selectFileOrFolder(caption:string; var fileOrFolder:string):boolean;
function isExtention(filename, ext:string):boolean;
function getMtimeUTC(filename:string):Tdatetime;
function getMtime(filename:string):Tdatetime;
// registry
function loadregistry(key,value:string; root:HKEY=0):string;
function saveregistry(key,value,data:string; root:HKEY=0):boolean;
function deleteRegistry(key,value:string; root:HKEY=0):boolean; overload;
function deleteRegistry(key:string; root:HKEY=0):boolean; overload;
// strings array
function split(separator, s:string):TStringDynArray;
function join(separator:string; ss:TstringDynArray):string;
function addUniqueString(s:string; var ss:TStringDynArray):boolean;
function addString(s:string; var ss:TStringDynArray):integer;
function popString(var ss:TstringDynArray):string;
procedure insertString(s:string; idx:integer; var ss:TStringDynArray);
procedure removeString(var ss:TStringDynArray; idx:integer; l:integer=1);
  overload;
procedure removeString(s:string; var ss:TStringDynArray); overload;
procedure removeStrings(s:string; var ss:TStringDynArray);
procedure toggleString(s:string; var ss:TStringDynArray);
procedure addArray(var a:TstringDynArray; b:array of string);
procedure uniqueStrings(var a:TstringDynArray);
function idxof(s:string; a:array of string):integer;
function stringExists(s:string; a:array of string):boolean;
function listToArray(l:Tstrings):TstringDynArray;
// convert
function ipToInt(ip:string):dword;
function rectToStr(r:Trect):string;
function strToRect(s:string):Trect;
function dt_(s:string):Tdatetime;
function int_(s:string):integer;
function str_(i:integer):string; overload;
function str_(fa:TfileAttributes):string; overload;
function str_(t:Tdatetime):string; overload;
function str_(b:boolean):string; overload;
function strToUInt(s:string):integer;
function elapsedToStr(t:Tdatetime):string;
function dateToHTTP(d:Tdatetime):string;
// misc string
function getStr(from,to_:pchar):string;
function chopLine(var s:widestring):widestring; overload;
function TLV(t:integer; data:string):string;
function TLV_NOT_EMPTY(t:integer; data:string):string;
function popTLV(var s,data:string):integer;
function getCRC(data:string):integer;
function kb(v:extended):string;
function dotted(i:int64):string;
function x_template(src:string; table:array of string):string;
function validUsername(s:string; acceptEmpty:boolean=FALSE):boolean;
function anycharIn(chars:string; s:string):boolean; overload;
function anycharIn(chars:Tcharset; s:string):boolean; overload;
function int0(i,digits:integer):string;
function includeTrailingChar(ch:char; s:string):string;
function addressmatch(mask, address:string):boolean;
function doubleAmp(s:string):string;
function getTill(ss, s:string):string;
function singleLine(s:string):boolean;
function poss(chars:TcharSet; s:string; ofs:integer=1):integer;
function optUTF8(bool:boolean; s:string):UTF8string;
function optAnsi(bool:boolean; s:string):string;
function utf8Test(s:string):boolean;
function jsEncode(s, chars:string):string;
function nonEmptyConcat(pre,s:string; post:string=''):string;
function firstNonEmpty(a,b:string; c:string=''):string;
function isOnlyDigits(s:string):boolean;
function stripChars(s:string; cs:Tcharset; strip:boolean=TRUE):string;
function reMatch(s, exp:string; caseInsens:boolean=FALSE; subexp:PstringDynArray=NIL):integer;

implementation

uses
  clipbrd, AnsiStringReplaceJOHIA32Unit13, regexpr;

var
  ipToInt_cache: ThashedStringList;

function reMatch(s, exp:string; caseInsens:boolean=FALSE; subexp:PstringDynArray=NIL):integer;
var
  i: integer;
begin
if assigned(subexp) then
  subexp^:=NIL;
result:=0;
with TRegExpr.Create do
  try
    try
      modifierI:=caseInsens;
      modifierM:=TRUE;
      expression:=exp;
      compile();
      if not exec(s) then exit;
      result:=MatchPos[0];
      if subexp = NIL then exit;
      i:=subExprMatchCount;
      setLength(subexp^, i+1); // it does include also the whole match, with index zero
      for i:=0 to i do
        subexp^[i]:=match[i]
    except end;
  finally free end
end; // reMatch

// converts from integer to string[4]
function str_(i:integer):string; overload;
begin
setlength(result, 4);
move(i, result[1], 4);
end; // str_

// converts from boolean to string[1]
function str_(b:boolean):string; overload;
begin result:=char(b) end;

// converts from TfileAttributes to string[4]
function str_(fa:TfileAttributes):string; overload;
begin result:=str_(integer(fa)) end;

// converts from Tdatetime to string[8]
function str_(t:Tdatetime):string; overload;
begin
setlength(result, 8);
move(t, result[1], 8);
end; // str_

// converts from string[4] to integer
function int_(s:string):integer;
begin result:=Pinteger(@s[1])^ end;

// converts from string[8] to datetime
function dt_(s:string):Tdatetime;
begin result:=Pdatetime(@s[1])^ end;

function strToUInt(s:string):integer;
begin
s:=trim(s);
if s='' then result:=0
else result:=strToInt(s);
if result < 0 then
  raise Exception.Create('strToUInt: Signed value not accepted');
end; // strToUInt

function split(separator, s:string):TStringDynArray;
var
  n: integer;
begin
n:=0;
result:=NIL;
while s > '' do
  begin
  if length(result) = n then setLength(result, n+50);
  result[n]:=chop(separator, s);
  inc(n);
  end;
setLength(result, n);
end; // split

function join(separator:string; ss:TstringDynArray):string;
var
  i:integer;
begin
result:='';
if length(ss) = 0 then exit;
result:=ss[0];
for i:=1 to length(ss)-1 do
  result:=result+separator+ss[i];
end; // join

procedure toggleString(s:string; var ss:TStringDynArray);
var
  i: integer;
begin
i:=idxOf(s, ss);
if i < 0 then addString(s, ss)
else removeString(ss, i);
end; // toggleString

procedure uniqueStrings(var a:TstringDynArray);
var
  i, j: integer;
begin
for i:=length(a)-1 downto 1 do
  for j:=i-1 downto 0 do
    if AnsiCompareText(a[i], a[j]) = 0 then
      begin
      removeString(a, i);
      break;
      end;
end; // uniqueStrings

// remove all instances of the specified string
procedure removeStrings(s:string; var ss:TStringDynArray);
var
  i, l: integer;
begin
  repeat
  i:=idxOf(s,ss);
  if i < 0 then break;
  l:=1;
  while (i+l < length(ss)) and (compareText(ss[i+l], s) = 0) do inc(l);
  removeString(ss, i, l);
  until false;
end; // removeStrings

// remove first instance of the specified string
procedure removeString(s:string; var ss:TStringDynArray);
begin removeString(ss, idxOf(s,ss)) end;

function popString(var ss:TstringDynArray):string;
begin
result:='';
if ss = NIL then exit;
result:=ss[0];
removeString(ss, 0);
end; // popString

function addString(s:string; var ss:TStringDynArray):integer;
begin
result:=length(ss);
insertString(s, result, ss)
end; // addString

function addUniqueString(s:string; var ss:TStringDynArray):boolean;
begin
result:=idxof(s, ss) < 0;
if result then insertString(s, length(ss), ss)
end; // addUniqueString

procedure insertstring(s:string; idx:integer; var ss:TStringDynArray);
var
  i:integer;
begin
i:=length(ss);
setLength(ss, i+1);
while i > idx do
  begin
  ss[i]:=ss[i-1];
  dec(i);
  end;
ss[i]:=s;
end; // insert

procedure removestring(var ss:TStringDynArray; idx:integer; l:integer=1);
begin
if (idx<0) or (idx >= length(ss)) then exit;
while idx+l < length(ss) do
  begin
  ss[idx]:=ss[idx+l];
  inc(idx);
  end;
setLength(ss, idx);
end; // removestring

function dotted(i:int64):string;
begin
result:=intToStr(i);
i:=length(result)-2;
while i > 1 do
  begin
  insert(ThousandSeparator, result, i);
  dec(i,3);
  end;
end; // dotted

function getRes(name:pchar; typ:string='TEXT'):string;
var
  h1, h2: Thandle;
  p: pchar;
  l: integer;
begin
result:='';
h1:=FindResource(HInstance, name, pchar(typ));
h2:=LoadResource(HInstance, h1);
if h2=0 then exit;
l:=SizeOfResource(HInstance, h1);
p:=LockResource(h2);
setLength(result, l);
move(p^, result[1], l);
UnlockResource(h2);
FreeResource(h2);
end; // getRes

function compare_(i1,i2:int64):integer; overload;
begin
if i1 < i2 then result:=-1 else
if i1 > i2 then result:=1 else
  result:=0
end; // compare_

function compare_(i1,i2:integer):integer; overload;
begin
if i1 < i2 then result:=-1 else
if i1 > i2 then result:=1 else
  result:=0
end; // compare_

function compare_(i1,i2:double):integer; overload;
begin
if i1 < i2 then result:=-1 else
if i1 > i2 then result:=1 else
  result:=0
end; // compare_

function rectToStr(r:Trect):string;
begin result:=format('%d,%d,%d,%d',[r.left,r.top,r.right,r.bottom]) end;

function strToRect(s:string):Trect;
begin
result.Left:=strToInt(chop(',',s));
result.Top:=strToInt(chop(',',s));
result.right:=strToInt(chop(',',s));
result.bottom:=strToInt(chop(',',s));
end; // strToRect

function TLV(t:integer; data:string):string;
begin result:=str_(t)+str_(length(data))+data end;

function TLV_NOT_EMPTY(t:integer; data:string):string;
begin if data > '' then result:=TLV(t,data) else result:='' end;

function popTLV(var s,data:string):integer;
begin
result:=-1;
if length(s) < 8 then exit;
result:=integer((@s[1])^);
data:=copy(s,9,Pinteger(@s[5])^);
delete(s,1,8+length(data));
end; // popTLV

function getCRC(data:string):integer;
var
  i:integer;
  p:Pinteger;
begin
result:=0;
p:=@data[1];
for i:=1 to length(data) div 4 do
  begin
  inc(result, p^);
  inc(p);
  end;
end; // crc

function bmpToHico(bitmap:Tbitmap):hicon;
var
  iconX, iconY : integer;
  IconInfo: TIconInfo;
  IconBitmap, MaskBitmap: TBitmap;
  dx,dy,x,y: Integer;
  tc: TColor;
begin
if bitmap=NIL then
  begin
  result:=0;
  exit;
  end;
iconX := GetSystemMetrics(SM_CXICON);
iconY := GetSystemMetrics(SM_CYICON);
IconBitmap:= TBitmap.Create;
IconBitmap.Width:= iconX;
IconBitmap.Height:= iconY;
IconBitmap.TransparentColor:=Bitmap.TransparentColor;
tc:=Bitmap.TransparentColor and $FFFFFF;
Bitmap.transparent:=FALSE;
dx:=bitmap.width*2;
dy:=bitmap.height*2;
if (dx < iconX) and (dy < iconY) then
  begin
  IconBitmap.Canvas.brush.color:=tc;
  with IconBitmap.Canvas do fillrect(clipRect);
  x:=(iconX-dx) div 2;
  y:=(iconY-dy) div 2;
  IconBitmap.Canvas.StretchDraw(Rect(x,y,x+dx,y+dy), Bitmap);
  end
else
  IconBitmap.Canvas.StretchDraw(Rect(0, 0, iconX, iconY), Bitmap);
MaskBitmap:= TBitmap.Create;
MaskBitmap.Assign(IconBitmap);
with MaskBitmap.canvas do fillrect(cliprect);
IconInfo.fIcon:= True;
IconInfo.hbmMask:= MaskBitmap.MaskHandle;
IconInfo.hbmColor:= IconBitmap.Handle;
Result:= CreateIconIndirect(IconInfo);
MaskBitmap.Free;
IconBitmap.Free;
end; // bmpToHico

function msgDlg(msg:string; code:integer=0; title:string=''):integer;
var
  parent: Thandle;
begin
result:=0;
if msg='' then exit;
if code = 0 then code:=MB_OK+MB_ICONINFORMATION;
if screen.ActiveCustomForm = NIL then parent:=0
else parent:=screen.ActiveCustomForm.handle;
application.restore();
application.BringToFront();
title:=application.Title+ifThen(title > '', ' -- '+title);
result:=messageBox(parent, pchar(msg), pchar(title), code)
end; // msgDlg

function percent(v:Extended):string;
begin result:=FloatToStrF(v*100,ffFixed,3,1)+'%' end;

function kb(v:extended):string;
begin result:=FloatToStrF(v/1024,ffFixed,20,2) end;

function idxOf(s:string; a:array of string):integer;
begin result:=ansiIndexText(s,a) end;

function stringExists(s:string; a:array of string):boolean;
begin result:= idxOf(s,a) >= 0 end;

function isAbsolutePath(path:string):boolean;
begin result:=(path > '') and (path[1] = '\') or (length(path) > 1) and (path[2] = ':') end;

function loadFile(fn:string):string;
var
  f:file;
  bak: byte;
begin
result:='';
IOresult;
if not validFilepath(fn) then exit;
if not isAbsolutePath(fn) then chDir(exePath);
assignFile(f, fn);
bak:=fileMode;
fileMode:=0;
try
  reset(f,1);
  if IOresult <> 0 then exit;
  setLength(result, fileSize(f));
  blockRead(f, result[1], length(result));
  closeFile(f);
finally
  filemode:=bak;
  end;
end; // loadFile

function saveFile(var f:file; data:string):boolean; overload;
begin
blockWrite(f, data[1], length(data));
result:=IOresult=0;
end;

function getTempFilename():string;
var
  path: string;
begin
setLength(path, 1000);
setLength(path, getTempPath(length(path), @path[1]));
setLength(result, 1000);
if windows.getTempFileName(pchar(path),'hfs.',0,@result[1]) = 0 then result:=''
else setLength(result, StrLen(@result[1]));
end; // getTempFilename

function saveTempFile(data:string):string;
begin
result:=getTempFilename();
if result > '' then saveFile(result, data);
end; // saveTempFile

function loadregistry(key,value:string; root:HKEY=0):string;
var
  reg:Tregistry;
begin
result:='';
reg:=Tregistry.create;
if root > 0 then reg.RootKey:=root;

  try
    if reg.openKey(key, FALSE) then
      begin
      result:=reg.ReadString(value);
      reg.closeKey;
      end;
    reg.free
  except
    reg.free
  end
end; // loadregistry

function saveregistry(key,value,data:string; root:HKEY=0):boolean;
var
  reg:Tregistry;
begin
result:=FALSE;
reg:=Tregistry.create;
if root > 0 then reg.RootKey:=root;
try
  try
    reg.CreateKey(key);
    if reg.openKey(key, FALSE) then
      begin
      reg.WriteString(value,data);
      reg.closeKey;
      result:=TRUE;
      end;
  finally reg.free end
except end;
end; // saveregistry

function deleteRegistry(key,value:string; root:HKEY=0):boolean; overload;
var
  reg:Tregistry;
begin
reg:=Tregistry.create;
if root > 0 then reg.RootKey:=root;
result:=reg.OpenKey(key,FALSE) and reg.DeleteValue(value);
reg.free
end; // deleteRegistry

function deleteRegistry(key:string; root:HKEY=0):boolean; overload;
var
  reg:Tregistry;
  ss:TstringList;
  i:integer;
  deleteIt:boolean;
begin
reg:=Tregistry.create;
if root > 0 then reg.RootKey:=root;
result:=reg.DeleteKey(key);
// delete also parent keys, if empty
ss:=Tstringlist.create;
while key>'' do
  begin
  i:=LastDelimiter('\',key);
  if i=0 then break;
  setlength(key, i-1);
  if not reg.OpenKeyReadOnly(key) then break;
  reg.GetValueNames(ss);
  deleteIt:=(ss.count=0) and not reg.HasSubKeys;
  reg.CloseKey;
  if deleteit then reg.deleteKey(key)
  else break;
  end;
ss.free;
reg.free
end; // deleteRegistry

function resolveLnk(fn:string):string;
Var
  sl: IShellLink;
  buffer: array [0..MAX_PATH] of char;
  fd: Twin32finddata;
begin
result:=fn;
  try
    olecheck(coCreateInstance(CLSID_ShellLink, nil, CLSCTX_INPROC_SERVER,
      IShellLink, sl));
    olecheck((sl as IPersistFile).load(pwidechar(widestring(fn)), STGM_READ));
    olecheck(sl.resolve(0, SLR_ANY_MATCH or SLR_NO_UI));
    olecheck(sl.getPath(Buffer, MAX_PATH, fd, 0));
    result:=buffer;
  except // convertion failed, but keep original filename
  end;
end; // resolveLnk

function anycharIn(chars:Tcharset; s:string):boolean;
begin result:=poss(chars, s) > 0 end;

function anycharIn(chars:string; s:string):boolean;
var
  z: Tcharset;
  i: integer;
begin
z:=[];
for i:=1 to length(chars) do
  include(z, chars[i]);
result:=anyCharIn(z, s);
end;

function validUsername(s:string; acceptEmpty:boolean=FALSE):boolean;
begin
result:=(s = '') and acceptEmpty
  or (s > '') and not anycharIn('/\:?*"<>|;&@',s) and (length(s) <= 40)
end;
function validFilename(s:string):boolean;
begin result:=(s>'') and not anycharIn(ILLEGAL_FILE_CHARS, s) end;

function validFilepath(fn:string):boolean;
begin
result:=(poss([#0..#31], fn) = 0)
  and (length(fn) <= 255+ifThen((length(fn) > 2) and (fn[2] = ':'), 2))
end;

procedure exec(cmd:string; pars:string='');
begin shellexecute(0, 'open', pchar(cmd), pchar(pars), NIL, SW_SHOWNORMAL) end;

// exec but does not wait for the process to end
function execNew(cmd:string):boolean;
var
  si: TStartupInfo;
  pi: TProcessInformation;
begin
fillchar(si, sizeOf(si), 0);
fillchar(pi, sizeOf(pi), 0);
si.cb:=sizeOf(si);
result:=createProcess(NIL,pchar(cmd),NIL,NIL,FALSE,0,NIL,NIL,si,pi)
end; // execNew

function x_template(src:string; table:array of string):string;
var
  i:integer;
begin
result:=src;
i:=0;
while i < length(table) do
  begin
  result:=stringReplace(result,table[i],table[i+1],[rfReplaceAll,rfIgnoreCase]);
  inc(i,2);
  end;
end; // x_template

procedure addArray(var a:TstringDynArray; b:array of string);
var
  i,l:integer;
begin
l:=length(a);
setlength(a, l+length(b));
for i:=0 to length(b)-1 do
  a[l+i]:=b[i];
end; // addArray

function ifThen(v:boolean; v1,v2:int64):int64;
begin if v then result:=v1 else result:=v2 end;

function ifThen(v:boolean; v1:integer; v2:integer=0):integer;
begin if v then result:=v1 else result:=v2 end;

function ifThen(v:boolean; v1:Tobject; v2:Tobject=NIL):Tobject;
begin if v then result:=v1 else result:=v2 end;

function match(mask, fn:pchar):boolean;
begin
// 1 to 1 match
while not (mask^ in [#0,'*']) and (fn^ <> #0)
and ((upcase(mask^) = upcase(fn^)) or (mask^ = '?')) do
  begin
  inc(mask);
  inc(fn);
  end;
result:=(mask^=#0) and (fn^=#0);
if mask^ <> '*' then exit;
result:=TRUE;
inc(mask);
if mask^ = #0 then exit; // final *, anything matches
  repeat
  result:=match(mask, fn);
  inc(fn);
  until (fn^ = #0) or result;
end; // match

function filematch(mask, fn:string):boolean;
var
  invert: boolean;
begin
result:=TRUE;
invert:=FALSE;
while (mask > '') and (mask[1] = '\') do
  begin
  delete(mask,1,1);
  invert:=not invert;
  end;
while mask > '' do
  begin
  result:=match( pchar(chop(';',mask)), pchar(fn) );
  if result then break;
  end;
result:=result xor invert;
end; // filematch

function checkAddressSyntax(address:string; wildcards:boolean=TRUE):boolean;
var
  a1, a2: string;
  i, dots: integer;
  wildcardsMet: boolean;
begin
result:=FALSE;
if address = '' then exit;
while (address > '') and (address[1] = '\') do delete(address,1,1);
while address > '' do
  begin
  a2:=chop(';', address);
  a1:=chop('-', a2);
  if a2 > '' then
    if not checkAddressSyntax(a1, FALSE)
    or not checkAddressSyntax(a2, FALSE) then
      exit;
  wildcardsMet:=FALSE;
  dots:=0;
  for i:=1 to length(a1) do
    case a1[i] of
      '.': inc(dots);
      '0'..'9': ;
      '?','*': if wildcards then wildcardsMet:=TRUE else exit;
      else exit;
      end;
  if (dots > 3) or not wildcardsMet and (dots <> 3) then exit;
  end;
result:=TRUE;
end; // checkAddressSyntax

function addressMatch(mask, address:string):boolean;
var
  invert: boolean;
  mask1, mask2: string;
  Iaddress: dword;
begin
result:=FALSE;
invert:=FALSE;
while (mask > '') and (mask[1] = '\') do
  begin
  delete(mask,1,1);
  invert:=not invert;
  end;
while mask > '' do
  begin
  mask2:=chop(';',mask);
  mask1:=chop('-', mask2);
  if mask2 = '' then result:=match( pchar(mask1), pchar(address) )
  else
    begin
    Iaddress:=ipToInt(address);
    result:=(Iaddress >= ipToInt(mask1)) and (Iaddress <= ipToInt(mask2));
    end;
  if result then break;
  end;
result:=result xor invert;
end; // addressMatch

function sizeOfFile(fh:Thandle):int64; overload;
var
  h, l: dword;
begin
l:=getFileSize(fh, @h);
if (l = $FFFFFFFF) and (getLastError() <> NO_ERROR) then result:=-1
else result:=l+int64(h) shl 32;
end; // sizeOfFile

function sizeOfFile(fn:string):int64; overload;
var
  h: Thandle;
begin
h:=fileopen(fn, fmOpenRead+fmShareDenyNone);
result:=sizeOfFile(h);
fileClose(h);
end; // sizeOfFile

function saveFile(fn:string; data:string; append:boolean=FALSE):boolean;
var
  f: file;
  path: string;
begin
result:=FALSE;
try
  if not validFilepath(fn) then exit;
  path:=extractFilePath(fn);
  if (path > '') and not forceDirectories(path) then exit;
  IOresult;
  assignFile(f, fn);
  if not append then
    rewrite(f,1)
  else
    begin
    reset(f,1);
    if IOresult() <> 0 then rewrite(f,1)
    else seek(f,fileSize(f));
    end;
  if IOresult <> 0 then exit;
  if not saveFile(f, data) then exit;
  closeFile(f);
  result:=TRUE;
except end;
end; // saveFile

function appendFile(fn:string; data:string):boolean;
begin result:=saveFile(fn, data, TRUE) end;

function min(a,b:integer):integer;
begin if a>b then result:=b else result:=a end;

function fileOrDirExists(fn:string):boolean;
var
  sr:TsearchRec;
begin
result:= 0=findFirst(ExcludeTrailingPathDelimiter(fn),faAnyFile,sr);
if result then FindClose(sr);
end; // fileOrDirExists

function int0(i,digits:integer):string;
begin
result:=intToStr(i);
result:=stringOfChar('0',digits-length(result))+result;
end; // int0

function includeTrailingChar(ch:char; s:string):string;
begin if (s='') or (s[length(s)] <> ch) then result:=s+ch else result:=s end;

function elapsedToStr(t:Tdatetime):string;
var
  sec: integer;
begin
sec:=trunc(t*SECONDS);
result:=format('%d:%.2d:%.2d', [sec div 3600, sec div 60 mod 60, sec mod 60] );
end; // elapsedToStr

// ensure f.accounts does not store unexistant users
function cbPurgeVFSaccounts(f:Tfile; par:integer):boolean;
var
  i: integer;
  usernames: TStringDynArray;
begin
result:=TRUE;
usernames:=TStringDynArray(par);
for i:=length(f.accounts)-1 downto 0 do
  if (f.accounts[i] = '')
  or (f.accounts[i][1] <> '@') and (idxOf(f.accounts[i], usernames) < 0) then
    removeString(f.accounts, i);
end; // cbpurgeVFSaccounts

procedure purgeVFSaccounts();
var
  usernames: TStringDynArray;
  i: integer;
begin
usernames:=NIL;
for i:=0 to length(accounts)-1 do addString(accounts[i].user, usernames);
rootFile.recursiveApply(cbPurgeVFSaccounts, integer(usernames));
end; // purgeVFSaccounts

function inputQueryLong(const caption, msg:string; var value:string; ofs:integer=0):boolean;
begin
inputQueryLongdlg.Caption:=caption;
inputQueryLongdlg.msgLbl.Caption:='  '+x_template(msg, [#13,#13'  '] );
inputQueryLongdlg.inputBox.Text:=value;
inputQueryLongdlg.inputBox.SelStart:=ofs;
// i want focus on the editor, but setFocus works only on visible windows -_-' any better idea?
inputQueryLongdlg.show();                                                   
inputQueryLongdlg.inputBox.SetFocus();
inputQueryLongdlg.hide();
result:=inputQueryLongdlg.ShowModal() = mrOk;
if result then value:=inputQueryLongdlg.inputBox.Text;
end; // inputQueryLong

function max(a,b:integer):integer;
begin if a > b then result:=a else result:=b end;

function httpGet(url:string):string;
var
  http: THttpCli;
  reply: Tstringstream;
begin
reply:=TStringStream.Create('');
try
  http:=Thttpcli.create(NIL);
  try
    http.URL:=url;
    http.RcvdStream:=reply;
    http.Agent:=HFS_HTTP_AGENT;
    try
      http.get();
      result:=reply.DataString;
    except result:='' end;
  finally http.free;
    end
finally reply.free;
  end
end; // httpGet

function httpFileSize(url:string):integer;
var
  http: THttpCli;
begin
http:=Thttpcli.create(NIL);
try
  http.URL:=url;
  http.Agent:=HFS_HTTP_AGENT;
  try
    http.head();
    result:=http.contentLength
  except result:=-1 end;
finally http.free;
  end
end; // httpFileSize

function httpGetFile(url, filename:string; notify:TdocDataEvent=NIL):boolean;
var
  http: THttpCli;
  reply: Tfilestream;
  supposed: integer;
begin
reply:=TfileStream.Create(filename, fmCreate);
try
  http:=Thttpcli.create(NIL);
  try
    http.URL:=url;
    http.RcvdStream:=reply;
    http.Agent:=HFS_HTTP_AGENT;
    http.OnDocData:=notify;
    result:=TRUE;
    try http.get()
    except result:=FALSE end;
    supposed:=http.ContentLength;
  finally http.free;
    end
finally reply.free;
  end;
result:= result and (sizeOfFile(filename)=supposed);
if not result then deleteFile(filename);
end; // httpGetFile

function getExternalAddress(var res:string):boolean;

  procedure loadIPservices();
  var
    s, l:string;
  begin
  IPservices:=NIL;
  s:=httpGet(IP_SERVICES_URL);
  while s > '' do
    begin
    l:=chopLine(s);
    if ansiStartsText('http://',l) then addString(l, IPservices);
    end;
  end; // loadIPservices

var
  s, mark, addr: string;
  i: integer;
begin
result:=FALSE;
if customIPservice > '' then s:=customIPservice
else
  begin
  if IPservices = NIL then loadIPservices();
  if IPservices = NIL then addArray(IPservices, FACTORY_IP_SERVICES);
  s:=IPservices[random(length(IPservices))];
  end;
addr:=chop('|',s);
mark:=s;
s:=httpGet(addr);
if mark > '' then chop(mark, s);
if s = '' then exit;
// try to determine length
i:=1;
while (i < length(s)) and (i < 15) and (s[i+1] in ['0'..'9','.']) do inc(i);
while (i > 0) and (s[i] = '.') do dec(i);
setLength(s,i);
result:= checkAddressSyntax(s) and not isLocalIP(s);
if result then res:=s;
end; // getExternalAddress

function whatStatusPanel(statusbar:Tstatusbar; x:integer):integer;
var
  x1: integer;
begin
result:=0;
x1:=statusbar.panels[0].width;
while (x > x1) and (result < statusbar.Panels.Count-1) do
  begin
  inc(result);
  inc(x1, statusbar.panels[result].width);
  end;
end; // whatStatusPanel

function getIPs():string;
begin
result:=localIPlist.text;
if (externalIP > '') and (localIPlist.IndexOf(externalIP) < 0) then
  result:=result+externalIP+CRLF;
end; // getIPs

function getPossibleAddresses():TstringDynArray;
begin
result:=listToArray(localIPlist);
addArray(result, [externalIP, dyndns.host]);
addArray(result, customIPs);
removeStrings('', result);
uniqueStrings(result);
end; // getPossibleAddresses

function getFilename(var f:file):string;
begin result:=pchar(@f)+72 end;

function filenameToDriveByte(fn:string):byte;
begin
if (length(fn) < 2) or (fn[2] <> ':') then fn:=exePath; // relative paths are actually based on the same drive of the executable
result:=ord(upcase(fn[1]))-ord('A')+1;
end; // filenameToDriveByte

function smartsize(size:int64):string;
begin
if size < 0 then result:='N/A'
else
  if size < 1 shl 10 then result:=format('%d B',[size])
  else
    if size < 1 shl 20 then result:=format('%f KB',[size/(1 shl 10)])
    else
      if size < 1 shl 30 then result:=format('%f MB',[size/(1 shl 20)])
      else result:=format('%f GB',[size/(1 shl 30)])
end; // smartsize

function doubleAmp(s:string):string;
begin result:=ansiReplaceStr(s,'&','&&') end;

function rtfcallback(dwCookie:dword; pbBuff:Pbyte; cb:integer;
  pcb:Pinteger):dword; stdcall;
var
  runner: ^pchar;
begin
result:=0;
runner:=pointer(dwCookie);
pcb^:=min(cb, strlen(runner^));
move(runner^^, pbbuff^, pcb^);
inc(runner^, pcb^);
end; // rtfcallback

function copyRTFtoRichEdit(rtf:string; richedit:Trichedit):boolean;
var
  es: EDITSTREAM;
  runner: pchar;
begin
result:=TRUE;
runner:=@rtf[1];
es.dwCookie:=integer(@runner);
es.dwError:=0;
es.pfnCallback:=@rtfcallback;
sendMessage(richedit.Handle, EM_STREAMIN, SF_RTF, LPARAM(@es));
end; // copyRTFtoRichEdit

function cbSelectFolder(wnd:HWND; uMsg:UINT; lp,lpData:LPARAM):LRESULT; stdcall;
begin
result:=0;
if (uMsg <> BFFM_INITIALIZED) or (lpdata = 0) then exit;
SendMessage(wnd, BFFM_SETSELECTION, 1, LPARAM(pchar(lpdata)));
SendMessage(wnd, BFFM_ENABLEOK, 0, 1);
end; // cbSelectFolder

function selectWrapper(caption:string; var from:string; flags:dword=0):boolean;
const
  BIF_NEWDIALOGSTYLE = $40;
  BIF_UAHINT = $100;
  BIF_SHAREABLE = $8000;
var
  bi: TBrowseInfo;
  res: PItemIDList;
  buff: array [0..MAX_PATH] of char;
  im: iMalloc;
begin
result:=FALSE;
if SHGetMalloc(im) <> 0 then exit;
bi.hwndOwner:=GetActiveWindow();
bi.pidlRoot:=NIL;
bi.pszDisplayName:=@buff;
bi.lpszTitle:=pchar(caption);
bi.ulFlags:=BIF_RETURNONLYFSDIRS+BIF_NEWDIALOGSTYLE+BIF_SHAREABLE+BIF_UAHINT
  +BIF_EDITBOX+flags;
bi.lpfn:=@cbSelectFolder;
bi.lParam:=integer(@from[1]);
bi.iImage:=0;
res:=SHBrowseForFolder(bi);
if res = NIL then exit;
if not SHGetPathFromIDList(res, buff) then exit;
im.Free(res);
from:=buff;
result:=TRUE;
end; // selectWrapper

function selectFolder(caption:string; var folder:string):boolean;
begin result:=selectWrapper(caption, folder) end;

// works only on XP
function selectFileOrFolder(caption:string; var fileOrFolder:string):boolean;
begin result:=selectWrapper(caption, fileOrFolder, BIF_BROWSEINCLUDEFILES) end;

function chop(i, l:integer; var s:widestring):widestring; overload;
begin
if i=0 then
  begin
  result:=s;
  s:='';
  exit;
  end;
result:=copy(s,1,i-1);
delete(s,1,i-1+l);
end; // chop

function chopLine(var s:widestring):widestring; overload;
begin
result:=chop(pos(#10,s),1,s);
if (result>'') and (result[length(result)]=#13) then
  setlength(result, length(result)-1);
end;

function safeDiv(a,b:real):real; overload;
begin if b=0 then result:=0 else result:=a/b end;

function safeDiv(a,b:int64; default:int64=0):int64; inline;
begin if b=0 then result:=default else result:=a div b end;

function isExtention(filename, ext:string):boolean;
begin result:= 0=ansiCompareText(ext, extractFileExt(filename)) end;

function getTill(ss, s:string):string;
var
  i: integer;
begin
i:=pos(ss, s);
if i = 0 then result:=s
else result:=copy(s,1,i-1);
end; // getTill

function dateToHTTP(d:Tdatetime):string;
const
  DOW2STR: array [1..7] of string=( 'Sun','Mon','Tue','Wed','Thu','Fri','Sat' );
  MONTH2STR: array [1..12] of string = ( 'Jan','Feb','Mar','Apr','May','Jun',
    'Jul','Aug','Sep','Oct','Nov','Dec' );
begin
result:=formatDateTime('"'+DOW2STR[dayOfWeek(d)]+'," dd "'+MONTH2STR[monthOf(d)]
  +'" yyyy hh":"nn":"ss "GMT"', d);
end; // dateToHTTP

function getMtimeUTC(filename:string):Tdatetime;
var
  sr: TsearchRec;
  st: TSystemTime;
begin
result:=0;
if findFirst(filename, faAnyFile, sr) <> 0 then exit;
FileTimeToSystemTime(sr.FindData.ftLastWriteTime, st);
result:=SystemTimeToDateTime(st);
findClose(sr);
end; // getMtimeUTC

function getMtime(filename:string):Tdatetime;
var
  i: integer;
begin
i:=FileAge(filename);
if i = -1 then i:=0;
try result:=FileDateToDateTime(i);
except result:=0 end
end; // getMtime

function ipToInt(ip:string):dword;
var
  i: integer;
begin
i:=ipToInt_cache.Add(ip);
result:=dword(ipToInt_cache.Objects[i]);
if result <> 0 then exit;
result:=WSocket_ntohl(WSocket_inet_addr(pchar(ip)));
ipToInt_cache.Objects[i]:=Tobject(result);
end; // ipToInt

function getShellFolder(id:string):string;
begin
result:=loadregistry(
  'Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders', id,
  HKEY_CURRENT_USER);
end; // getShellFolder

function createShellLink(linkFN:WideString; destFN:string):boolean;
var
  ShellObject: IUnknown;
begin
shellObject:=CreateComObject(CLSID_ShellLink);
result:=((shellObject as IShellLink).setPath(PChar(destFN)) = NOERROR)
  and ((shellObject as IPersistFile).Save(PWChar(linkFN), False) = S_OK)
end; // createShellLink

function selectFiles(caption:string; var files:TStringDynArray):boolean;
var
  dlg: TopenDialog;
  i: integer;
begin
dlg:=TopenDialog.create(screen.activeForm);
try
  dlg.Options:=dlg.Options+[ofAllowMultiSelect, ofFileMustExist, ofPathMustExist];
  result:=dlg.Execute();
  if result then
    begin
    setLength(files, dlg.Files.count);
    for i:=0 to dlg.files.Count-1 do
      files[i]:=dlg.files[i];
    end;
finally dlg.free;
  end;
end;

function eos(s:Tstream):boolean;
begin result:=s.position >= s.size end;

function singleLine(s:string):boolean;
var
  i, l: integer;
begin
i:=pos(#13,s);
l:=length(s);
result:=(i = 0) or (i = l) or (i = l-1) and (s[l] = #10)
end; // singleLine

function setClip(s:string):boolean;
begin
result:=TRUE;
try clipboard.AsText:=s
except result:=FALSE end;
end; // setClip

function gap512(i:integer):integer; assembler;
asm
mov EAX, i
and EAX, 511
jz  @END
mov EDX, 512
sub EDX, EAX
mov EAX, EDX
@END:
end; // gap512

function getStr(from, to_:pchar):string;
var
  l: integer;
begin
result:='';
if (from = NIL) or assigned(to_) and (from > to_) then exit;
if to_ = NIL then
  begin
  to_:=strEnd(from);
  dec(to_);
  end;
l:=to_-from+1;
setLength(result, l);
if l > 0 then strLcopy(@result[1], from, l);
end; // getStr

function pred(p:pchar):pchar; overload;
begin
result:=p;
if result <> NIL then dec(result);
end; // pred

function poss(chars:TcharSet; s:string; ofs:integer=1):integer;
begin
delete(s,1,ofs-1);
for result:=1 to length(s) do
  if s[result] in chars then exit;
result:=0;
end; // poss

function isNT():boolean;
var
  vi: TOSVERSIONINFO;
begin
result:=TRUE;
vi.dwOSVersionInfoSize:=sizeOf(vi);
if not getVersionEx(vi) then exit;
result:= vi.dwPlatformId = VER_PLATFORM_WIN32_NT;
end; // isNT

function getTempDir():string;
begin
setLength(result, 1000);
setLength(result, getTempPath(length(result), @result[1]));
end; // getTempDir

function optUTF8(bool:boolean; s:string):UTF8string;
begin if bool then result:=AnsiToUtf8(s) else result:=s end;

function optAnsi(bool:boolean; s:string):string;
begin if bool then result:=UTF8toAnsi(s) else result:=s end;

function blend(from,to_:Tcolor; perc:real):Tcolor;
var
  i: integer;
begin
result:=0;
from:=ColorToRGB(from);
to_:=ColorToRGB(to_);
for i:=0 to 2 do
  inc(result, min($FF, round(((from shr (i*8)) and $FF)*(1-perc)
    +((to_ shr (i*8)) and $FF)*perc)) shl (i*8));
end; // blend

function listToArray(l:Tstrings):TstringDynArray;
var
  i: integer;
begin
try
  setLength(result, l.Count);
  for i:=0 to l.Count-1 do
    result[i]:=l[i];
except
  result:=NIL
  end
end; // listToArray

function jsEncode(s, chars:string):string;
var
  i: integer;
begin
for i:=1 to length(chars) do
  s:=ansiReplaceStr(s, chars[i], '\x'+intToHex(ord(chars[i]),2));
result:=s;
end; // jsEncode

function holdingKey(key:integer):boolean;
begin result:=getAsyncKeyState(key) and $8000 <> 0 end;

function utf8Test(s:string):boolean;
begin result:=ansiContainsText(s, '=UTF-8') end;

function nonEmptyConcat(pre, s:string; post:string=''):string;
begin if s = '' then result:='' else result:=pre+s+post end;

function firstNonEmpty(a,b:string; c:string=''):string;
begin
if a > '' then result:=a
else if b > '' then result:=b
else result:=c
end; // firstNonEmpty

// taken from http://www.delphi3000.com/articles/article_3361.asp
function captureExec(DosApp : string):string;
const
  ReadBuffer = 1048576;  // 1 MB Buffer
var
  sa            : TSecurityAttributes;
  ReadPipe,WritePipe  : THandle;
  start               : TStartUpInfo;
  ProcessInfo         : TProcessInformation;
  Buffer              : Pchar;
  TotalBytesRead,
  BytesRead           : DWORD;
  Apprunning,n,
  BytesLeftThisMessage,
  TotalBytesAvail : integer;
begin
sa.nlength:=SizeOf(sa);
sa.binherithandle:=TRUE;
sa.lpsecuritydescriptor:=NIL;

if not createPipe(ReadPipe, WritePipe, @sa, 0) then exit;
// Redirect In- and Output through STARTUPINFO structure
Buffer:=AllocMem(ReadBuffer + 1);
FillChar(Start,Sizeof(Start),#0);
start.cb:= SizeOf(start);
start.hStdOutput:= WritePipe;
start.hStdInput:= ReadPipe;
start.dwFlags:= STARTF_USESTDHANDLES + STARTF_USESHOWWINDOW;
start.wShowWindow:= SW_HIDE;
// Create a Console Child Process with redirected input and output
if CreateProcess(nil, PChar(DosApp), @sa, @sa, true,
  CREATE_NO_WINDOW or NORMAL_PRIORITY_CLASS, nil, nil, start, ProcessInfo) then
  begin
  n:=0;
  TotalBytesRead:=0;
    repeat
    // wait for end of child process
    Apprunning := WaitForSingleObject(ProcessInfo.hProcess,100);
    Application.ProcessMessages();
    // it is important to read from time to time the output information
    // so that the pipe is not blocked by an overflow. New information
    // can be written from the console app to the pipe only if there is
    // enough buffer space.
    if not PeekNamedPipe(ReadPipe, @Buffer[TotalBytesRead], ReadBuffer,
      @BytesRead, @TotalBytesAvail, @BytesLeftThisMessage ) then
      break
    else if BytesRead > 0 then
      ReadFile(ReadPipe, Buffer[TotalBytesRead], BytesRead, BytesRead, nil );
    inc(TotalBytesRead, BytesRead);
    // Increase counter to prevent an endless loop if the process is dead
    Inc(n);
    until (Apprunning <> WAIT_TIMEOUT) or (n > 150);
  Buffer[TotalBytesRead]:= #0;
  OemToChar(Buffer,Buffer);
  result:=result+StrPas(Buffer);
  end;
TerminateProcess(ProcessInfo.hProcess, 0);
FreeMem(Buffer);
CloseHandle(ProcessInfo.hProcess);
CloseHandle(ProcessInfo.hThread);
CloseHandle(ReadPipe);
CloseHandle(WritePipe);
end; // captureExec

function port2pid(port:integer):integer;
var
  s, l, p, portS: string;
begin
result:=-1;
portS:=intToStr(port);
s:=captureExec('netstat -naop tcp');
while s > '' do
  begin
  l:=chopline(s);
  if Pos('LISTENING', l) = 0 then continue;
  chop(':', l);
  p:=chop(' ',l);
  if p <> portS then continue;
  chop('LISTENING', l);
  result:=strToIntDef(trim(l), -1);
  exit;
  end;
end; // port2pid

function pid2file(pid:integer):string;
var
  h: Thandle;
begin
result:='';
h:=openProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, FALSE, pid);
if h = 0 then exit;
try
  setLength(result, MAX_PATH);
  if getModuleFileNameEx(h, 0, pchar(Result), MAX_PATH) > 0 then
    setLength(result, strLen(pchar(result)))
  else
    result:=''
finally
  closeHandle(h)
  end;
end; // pid2file

function stripChars(s:string; cs:Tcharset; strip:boolean=TRUE):string;
var
  i, l, ofs: integer;
  b: boolean;
begin
l:=length(s);
i:=1;
ofs:=0;
while i+ofs <= l do
  begin
  b:=not (s[i+ofs] in cs) xor strip;
  if b then inc(ofs);
  if i+ofs > l then break;
  if ofs > 0 then s[i]:=s[i+ofs];
  if not b then inc(i);
  end;
setLength(s, l-ofs);
result:=s;
end; // stripChars

function isOnlyDigits(s:string):boolean;
var
  i: integer;
begin
result:=FALSE;
for i:=length(s) downto 1 do
  if not (s[i] in ['0'..'9']) then
    exit;
result:=TRUE;
end; // isOnlyDigits

var
  TZinfo:TTimeZoneInformation;

INITIALIZATION
ipToInt_cache:=THashedStringList.Create;
ipToInt_cache.Sorted:=TRUE;
ipToInt_cache.Duplicates:=dupIgnore;
inputQueryLongdlg:=TlonginputFrm.create(NIL); // mainFrm is NIL at this time

// calculate GMToffset
GetTimeZoneInformation(TZinfo);
case GetTimeZoneInformation(TZInfo) of
  TIME_ZONE_ID_STANDARD: GMToffset:=TZInfo.StandardBias;
  TIME_ZONE_ID_DAYLIGHT: GMToffset:=TZInfo.DaylightBias;
  else GMToffset:=0;
  end;
GMToffset:=-(TZinfo.bias+GMToffset);

// windows version detect
case byte(getversion()) of
  1..4: winVersion:=WV_LOWER;
  5: winVersion:=WV_2000;
  6: winVersion:=WV_VISTA;
  7..15: winVersion:=WV_HIGHER;
  end;

trayMsg:='%ip%'
  +trayNL+'Uptime: %uptime%'
  +trayNL+'Downloads: %downloads%';


FINALIZATION
ipToInt_cache.free;
inputQueryLongdlg.free;

end.
